% sample data
clear all; clc; close all;
% tic
load strokeUniGenes
load human_DBPPI
% elapsetime1 = toc
%% candidate network
% genes = expr_uni.RowNames;
% expr = double(expr_uni.(':')(':'));
Lia = ismember(human_DBPPI,genes);
netCand = human_DBPPI(find(Lia(:,1)+Lia(:,2)==2),:);
netCandList = unique([netCand(:,1);netCand(:,2)]);
LiA = ismember(genes,netCandList);
expr_cand = expr(find(LiA),:);
geneCand = genes(find(LiA),:);
D = zeros(size(netCand,1),3);
D(:,3) = 1;
parfor i = 1:length(netCand)
    for j = 1:2
        D(i,j) = find(strcmp(netCand(i,j),netCandList));
    end
end
matrixCand = spconvert(D);
matrixCand = matrixCand+matrixCand';

%% real network
expr_control = expr_cand(:,1:23);
expr_3h = expr_cand(:,24:46);
expr_5h = expr_cand(:,47:69);
expr_24h = expr_cand(:,70:92);
% elapsetime2 = toc
[ctrlNet,ctrlSelf] = PPIconstruction(geneCand,matrixCand,expr_control);
% elapsetime3 = toc
% [firstNet,firstSelf] = PPIconstruction(geneCand,matrixCand,expr_3h);
% elapsetime4 = toc
% [secondNet,secondSelf] = PPIconstruction(geneCand,matrixCand,expr_5h);
% elapsetime5 = toc
% [thirdNet,thirdSelf] = PPIconstruction(geneCand,matrixCand,expr_24h);
% elapsetime6 = toc
% fileID = fopen('exp.txt','w');
% fprintf(fileID,'It takes \n %g sec to load files,\n %g sec to construct candidate netowrk',elapsetime1,elapsetime2);
% fprintf(fileID,'\n %g sec to construct ctrlNet,\n %g sec to construct firstNet',elapsetime3,elapsetime4);
% fprintf(fileID,'\n %g sec to construct secondNet,\n %g sec to construct thirdNet',elapsetime5,elapsetime6);
% fclose(fileID);
%% iteration
load thirdNetwork
tic
netOld = matrixCand;
netNew = thirdNet;
i = 0;
while (nnz(netNew)-nnz(netOld) ~= 0)
    netOld = netNew;
    matrix = spones(netOld);
    matrix = matrix+matrix';
    [netNew,self] = PPIconstruction(geneCand,matrix,expr_control);
    i = i+1;
end
thirdNode = [geneCand(self(:,1),1),num2cell(self(:,2))];
thirdEdge = matrixToList(netNew,geneCand);
elapsetime = toc
fileID = fopen('thirdRefine.txt','w');
fprintf(fileID,'It takes %g loops and %g sec to construct thirdNetowrk',i,elapsetime);
fclose(fileID);